;~@sa1
;this is the left bottom-half cap of a horizontal 1-way pipe, can
;be used as a small pipe and normal-sized pipe cap.
;behaves $130

incsrc "SSPDef/Defines.asm"

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP return : JMP return : JMP return
JMP return : JMP TopCorner : JMP BodyInside : JMP HeadInside


MarioSide:
	LDA !Freeram_PipeDir		;\for other offsets if mario
	BEQ return		;/not in pipe
	CMP #$04		;\if going left then exit
	BEQ exit		;/
TopCorner:
MarioAbove:
HeadInside:
BodyInside:
MarioBelow:
within_pipe:
	JSR passable
	RTL
exit:
	REP #$20
	LDA $9A			;\If mario is touching only the
	AND #$FFF0		;|right side of cap, then don't do...
	CLC			;\(this moves the boundary leftwards, due
	ADC #$0004		;/to a bug with $9A doesn't update as fast as $94)
	CMP $94			;|...anything except become passable.
	SEP #$20		;|(So it doesn't snap mario about #$10 pixels)
	BCC within_pipe		;/
	LDA !Freeram_EntrExtFlg	;\do nothing if already exiting pipe
	CMP #$02
	BEQ within_pipe		;/
	LDA #$02		;\set exiting flag
	STA !Freeram_EntrExtFlg	;/
	LDA #$08		;\Set mario's movement as if he's exiting
	STA !Freeram_PipeDir		;/a vanilla pipe
	REP #$20		;\center horizontally so if left and right
	LDA $9A			;|caps are touching each other won't exit
	AND #$FFF0		;|incorrectly.
	STA $94			;|
	SEP #$20		;/
	LDA #$1B		;\set exit the pipe timer (same as smw's $7E0088)
	STA !Freeram_PipeTmr		;/
	JSR passable		;>become passable
	LDA #$04		;\pipe sound
	STA $1DF9|!addr		;/
	STZ $7B			;\Prevent centering, and then displaced by xy speeds.
	STZ $7D			;/
	STZ $76			;>don't exit backwards.
	%FaceYoshi()
return:
	RTL
passable:
	LDA !Freeram_PipeDir		;\not in pipe = solid
	BEQ solid_out		;/
	LDY #$00		;\mario passes through the block
	LDA #$25		;|
	STA $1693|!addr		;/
solid_out:
	RTS
center_vert:
	LDA $187A|!addr
	BNE yoshi_center
	REP #$20
	LDA $98
	AND #$FFF0
	SEC : SBC #$0011
	STA $96
	SEP #$20
	RTS
yoshi_center:
	REP #$20
	LDA $98
	AND #$FFF0
	SEC : SBC #$0021
	STA $96
	SEP #$20
	RTS
if !discription != 0
print "Bottom-left/left cap exit piece of horizontal pipe."
endif