;~@sa1
;this is the left bottom-half cap of a horizontal 2-way pipe. (no yoshi allowed)
;behaves $130

incsrc "SSPDef/Defines.asm"

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP return : JMP return : JMP return
JMP return : JMP TopCorner : JMP BodyInside : JMP HeadInside


return2:
	LDA #$20
	STA $1DF9|!addr
	RTL

MarioSide:
	LDA !Freeram_PipeDir		;\If mario isn't in a pipe, the run the enter routine
	BEQ enter		;/
	CMP #$04		;\If mario is going outwards from the cap heading left,
	BEQ exit		;/then exit
	BRA within_pipe
enter:
	if !carryallowed == 0
		LDA $1470|!addr		;\no carrying item
		ORA $148F|!addr		;|
		BNE return		;/
	endif
	LDA $187A|!addr		;\do not enter pipe when turning
	CMP #$02		;|around on yoshi.
	BEQ return		;/
	LDA $1471|!addr		;>so vertical centering code works
	BNE return
	LDA !Freeram_BlockedStatBkp	;\If you are not on ground, return
	AND.b #%00000100		;|
	BEQ return			;/
	LDA $15			;\must press right
	AND #$01		;|
	BEQ return		;/
	LDA $76			;\must face right
	BEQ return		;/
	LDA $187A|!addr
	BNE return2
	LDA $1470|!addr		;\if mario not carrying anything
	ORA $148F|!addr		;|then skip
	BEQ .not_carry		;/
	LDA #$01		;\set flag
	STA !Freeram_CarrySpr	;/
.not_carry
	LDA #$3C		;\Set timer.
	STA !Freeram_PipeTmr		;/
	LDA #$04		;\pipe sound
	STA $1DF9|!addr		;/
	STZ $7B			;\Prevent centering, and then displaced by xy speeds.
	STZ $7D			;/
	LDA #$06		;\set his direction to entering
	STA !Freeram_PipeDir	;/
	LDA #$01		;\set flag to "entering"
	STA !Freeram_EntrExtFlg	;/
	JSR center_vert
within_pipe:
	JSR passable
return:
	RTL
TopCorner:
MarioAbove:
HeadInside:
BodyInside:
MarioBelow:
	LDA !Freeram_PipeDir		;\for other offsets if mario
	BEQ return		;/not in pipe
	CMP #$04		;\if going left then exit
	BEQ exit		;/
	BRA within_pipe
exit:
	REP #$20
	LDA $9A			;\If mario is touching only the
	AND #$FFF0		;|right side of cap, then don't do
	CLC			;\(this moves the boundary leftwards, due
	ADC #$0004		;/to a bug with $9A doesn't update as fast as $94)
	CMP $94			;|anything except become passable.
	SEP #$20		;|(So it doesn't snap mario about #$10 pixels)
	BCC within_pipe		;/
	LDA !Freeram_EntrExtFlg		;\do nothing if already exiting pipe
	CMP #$02
	BEQ within_pipe		;/
	LDA #$02		;\set exiting flag
	STA !Freeram_EntrExtFlg		;/
	LDA #$08		;\Set mario's movement as if he's exiting
	STA !Freeram_PipeDir		;/a vanilla pipe
	REP #$20		;\center horizontally so if left and right
	LDA $9A			;|caps are touching each other won't exit
	AND #$FFF0		;|incorrectly.
	STA $94			;|
	SEP #$20		;/
	LDA #$1B		;\set exit the pipe timer (same as smw's $7E0088)
	STA !Freeram_PipeTmr		;/
	JSR passable		;>become passable
	LDA #$04		;\pipe sound
	STA $1DF9|!addr		;/
	STZ $7B			;\Prevent centering, and then displaced by xy speeds.
	STZ $7D			;/
	STZ $76			;>mario faces left.

	%FaceYoshi()
return1:
	RTL
passable:
	LDY #$00		;\mario passes through the block
	LDA #$25		;|
	STA $1693|!addr		;/
	RTS
center_vert:
	LDA $187A|!addr
	BNE yoshi_center
	REP #$20
	LDA $98
	AND #$FFF0
	SEC : SBC #$0011
	STA $96
	SEP #$20
	RTS
yoshi_center:
	REP #$20
	LDA $98
	AND #$FFF0
	SEC : SBC #$0021
	STA $96
	SEP #$20
	RTS

if !discription != 0
print "Bottom-left cap piece of horizontal 2-way pipe."
endif