;~@sa1
;this is the right cap of a horizontal 2-way pipe that is
;only enterable as small mario (yoshi always not allowed).
;behaves $130

incsrc "SSPDef/Defines.asm"

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP return : JMP return : JMP return
JMP return : JMP TopCorner : JMP BodyInside : JMP HeadInside


MarioSide:
	LDA !Freeram_PipeDir		;\if not in pipe
	BEQ enter		;/then enter
	CMP #$02		;\if going right
	BEQ exit		;/then exit
	BRA within_pipe		;>other directions = pass
enter:
	LDA $187A|!addr		;>no yoshi.
	ORA $19			;>no powerup
	ORA $1471|!addr		;>so vertical centering code works
	ORA $76			;>must face left
	BEQ .SmallNoYoshi
	RTL			;>otherwise return
.SmallNoYoshi
	LDA !Freeram_BlockedStatBkp		;\If you are not on ground, return
	AND.b #%00000100		;|
	BEQ return			;/
if !carryallowed == 0
	LDA $1470|!addr		;\no carrying item
	ORA $148F|!addr		;|
	BNE return		;/
endif
	LDA $15			;\must press left
	AND #$02		;|
	BEQ return		;/
	LDA $1470|!addr		;\if mario not carrying anything
	ORA $148F|!addr		;|then skip
	BEQ not_carry		;/
	LDA #$01		;\set flag
	STA !Freeram_CarrySpr	;/
not_carry:
	LDA #$3A
	STA !Freeram_PipeTmr
	LDA #$04		;\pipe sound
	STA $1DF9|!addr		;/
	STZ $7B			;\Prevent centering, and then displaced by xy speeds.
	STZ $7D			;/
	LDA #$08		;\set his direction
	STA !Freeram_PipeDir		;/
	LDA #$01		;\set flag to "entering"
	STA !Freeram_EntrExtFlg	;/
	JSR center_vert
	JSR passable
	RTL
TopCorner:
MarioAbove:
HeadInside:
BodyInside:
MarioBelow:
within_pipe:
	JSR passable
	RTL
exit:
	REP #$20
	LDA $9A			;\If mario is touching only the
	AND #$FFF0		;|right side of cap, then don't do...
	SEC			;\(this moves the boundary leftwards, due
	SBC #$0004		;/to a bug with $9A doesn't update as fast as $94)
	CMP $94			;|...anything except becomme passable.
	SEP #$20		;|(So it doesn't snap mario about #$10 pixels)
	BCS within_pipe		;/
	LDA !Freeram_EntrExtFlg	;\do nothing if already exiting pipe
	CMP #$02
	BEQ within_pipe		;/
	LDA #$02		;\set exiting flag
	STA !Freeram_EntrExtFlg	;/
	LDA #$06		;\Set mario's movement as if he's exiting
	STA !Freeram_PipeDir		;/a vanilla pipe
	REP #$20		;\center horizontally so if left and right
	LDA $9A			;|caps are touching each other won't exit
	AND #$FFF0		;|incorrectly.
	STA $94			;|
	SEP #$20		;/
	LDA #$1B		;\set exit the pipe timer (same as smw's $7E0088)
	STA !Freeram_PipeTmr		;/
	JSR passable		;>become passable
	LDA #$04		;\pipe sound
	STA $1DF9|!addr		;/
	STZ $7B			;\Prevent centering, and then displaced by xy speeds.
	STZ $7D			;/
	LDA #$01		;\don't exit backwards.
	STA $76			;/
	JSR center_vert
return:
	RTL
passable:
	LDA !Freeram_PipeDir		;\not in pipe = solid
	BEQ solid_out		;/
	LDY #$00		;\mario passes through the block
	LDA #$25		;|
	STA $1693|!addr		;/
solid_out:
	RTS
center_vert:
;	LDA $187A|!addr
;	BNE yoshi_center
	REP #$20
	LDA $98
	AND #$FFF0
	SEC : SBC #$0011
	STA $96
	SEP #$20
	RTS
;yoshi_center:
;	REP #$20
;	LDA $98
;	AND #$FFF0
;	SEC : SBC #$0021
;	STA $96
;	SEP #$20
;	RTS
if !discription != 0
print "Right cap piece of horizontal pipe for small mario."
endif