;~@sa1
;This is the top right-half cap of a vertical two-way pipe. (no yoshi allowed)
;behaves $130

incsrc "SSPDef/Defines.asm"

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP return : JMP return : JMP return
JMP return : JMP TopCorner : JMP BodyInside : JMP HeadInside

return2:
	LDA #$20
	STA $1DF9|!addr
	RTL

TopCorner:
MarioAbove:			;>mario above only so he cannot enter edge and glitch
	LDA !Freeram_PipeDir		;\if not in pipe
	BEQ enter		;/then enter
	CMP #$01		;\exit if going up
	BEQ exit		;|
	CMP #$05		;|
	BEQ exit		;/
	BRA within_pipe		;>other directions = pass
enter:
	if !carryallowed == 0
		LDA $1470|!addr		;\no carrying item
		ORA $148F|!addr		;|
		BNE return		;/
	endif
	REP #$20		;\Must be on the correct side to enter.
	LDA $9A			;|
	AND #$FFF0		;|
	CMP $94			;|
	SEP #$20		;|
	BCS .MarioOnLeft	;>Branch out of bounds.
	RTL			;/
.MarioOnLeft
	LDA $15			;\must press down
	AND #$04		;|
	BNE .PressDown		;>Branch out of bounds.
	RTL			;/
.PressDown
	LDA $187A|!addr
	BNE return2
	LDA $1470|!addr		;\if mario not carrying anything
	ORA $148F|!addr		;|then skip
	BEQ .not_carry		;/
	LDA #$01		;\set carrying flag
	STA !Freeram_CarrySpr	;/
.not_carry

	PHX
	LDX $187A|!addr
	LDA.l YoshiTimersEnter,x
	STA !Freeram_PipeTmr
	PLX

	LDA #$04		;\pipe sound
	STA $1DF9|!addr		;/
	STZ $7B			;\Prevent centering, and then displaced by xy speeds.
	STZ $7D			;/
	LDA #$07		;\set his direction
	STA !Freeram_PipeDir		;/
	LDA #$01		;\set flag to "entering"
	STA !Freeram_EntrExtFlg	;/
	JSR center_horiz	;>center the player to pipe
within_pipe:
	JSR passable
	RTL
MarioSide:
HeadInside:
BodyInside:
MarioBelow:
	LDA !Freeram_PipeDir		;\return for other offsets
	BEQ return		;/when not in pipe
	CMP #$01		;\exit if going up
	BEQ exit		;/
	BRA within_pipe
exit:
	LDA $19			;\If you're small, don't need to check
	BEQ .Small		;/to avoid snapping y position
	REP #$20		;\When big mario, this prevents snapping
	LDA $98			;|the player upwards to the cap.
	AND #$FFF0		;|
	CLC			;|
	ADC #$0004		;|
	CMP $96			;|
	SEP #$20		;|
	BMI within_pipe		;|
.Small				;/
	LDA !Freeram_EntrExtFlg	;\do nothing if already exiting pipe
	CMP #$02
	BEQ within_pipe		;/
	LDA #$02		;\set exiting flag
	STA !Freeram_EntrExtFlg		;/
	JSR center_horiz	;>center the player horizontally
	JSR passable		;>be passable while exiting

	PHX
	LDX $187A|!addr
	LDA.l YoshiTimersExit,x
	STA !Freeram_PipeTmr
	PLX

	LDA #$04		;\pipe sound
	STA $1DF9|!addr		;/
	STZ $7B			;\Prevent centering, and then displaced by xy speeds.
	STZ $7D			;/
	LDA $187A|!addr		;\+1 block up for yoshi
	BNE .VCenter2		;/
	REP #$20		;\center vertically
	LDA $98			;|so it doesn't glitch if the bottom
	AND #$FFF0		;|and top caps are touching each other.
	STA $96			;|
	SEP #$20		;/
	RTL
.VCenter2
	REP #$20		;\center vertically + 1 block up
	LDA $98			;|so it doesn't glitch if the bottom
	AND #$FFF0		;|and top caps are touching each other.
	SEC : SBC #$000C	;|
	STA $96			;|
	SEP #$20		;/
return:
	RTL

center_horiz:
	REP #$20		;\center player to pipe horizontally.
	LDA $9A			;|
	AND #$FFF0		;|
	SEC : SBC #$0008	;|
	STA $94			;|
	SEP #$20		;/
	RTS
passable:
	LDY #$00		;\mario passes through the block
	LDA #$25		;|
	STA $1693|!addr		;/
	RTS

YoshiTimersExit:
	db $1D,$27,$27		;>Timers: 1st one = on foot, 2nd and 3rd one = on yoshi
YoshiTimersEnter:
	db $20,$30,$30
if !discription != 0
print "Top-right cap piece of vertical 2-way pipe."
endif