!lose_lives = $00		; $00 = no
				; $01 = yes
!counter_break = $01		; $00 = disable the counter break patch
				; $01 = enable the counter break patch
!death_sfx = $36		; the sfx used for type 01 or 02 of the retry prompt
!death_sfx_bank = $1DFC		; for the list of vanilla sfx, check https://www.smwcentral.net/?p=viewthread&t=6665
!death_jingle_alt = $29		; the alternative death jingle played after the death_sfx (option $01) when "no" is chosen.
				; set the value to $FF to disable this.



;!freeram: timer1
;!freeram+1: timer2
;!freeram+2: timer3
;!freeram+3: respawn location1
;!freeram+4: respawn location2
;!freeram+5: is respawning? (after death)
;!freeram+6: music that has to be reloaded after respawn
;!freeram+7: music sped up? (hurry up)
;!freeram+8: door dest1 (candidate of freeram+3, for door/pipe checkpoint)
;!freeram+9: door dest2 (candidate of freeram+4, for door/pipe checkpoint)
;!freeram+10: music played right before the death jingle
;!freeram+11: music registered(freeram+6) latest midway value (for mmp)


!sa1	= 0
!dp	= $0000
!addr	= $0000
!bank	= $800000
!bank8	= $80
!7ED000 = $7ED000		; $7ED000 if LoROM, $40D000 if SA-1 ROM.

if read1($00FFD5) == $23
	sa1rom
	!sa1	= 1
	!dp	= $3000
	!addr	= $6000
	!bank	= $000000
	!bank8	= $00
	!7ED000 = $40D000		; $7ED000 if LoROM, $40D000 if SA-1 ROM.
endif


incsrc ../global_settings.asm


org $00A1DF
autoclean JSL Prompt

org $0085D2
autoclean JML LoadScrnImage

org $00F5B2
autoclean JSL DeathSFX_pit

org $00F606
autoclean JML DeathSFX

org $008E5B
autoclean JML HurryFlag

org $00A28A
autoclean JML Request

; earlier than GeneralInit (between object & sprite)
org $05D8E6
autoclean JML GeneralInit0

org $0091A6
autoclean JML GeneralInit

org $02A768
autoclean JML YoshiInit

org $05D7BD
autoclean JML EntranceInit0

org $05D7D4
autoclean JML EntranceInit

org $00F2E8
autoclean JML MidbarHijack

org $0DA691
autoclean JML MidbarSpawn

org $05D9D7
autoclean JML CheckMidwayEntrance

org $0096CB
autoclean JML InitCheckpointRam

org $05D9EC
autoclean JML VanillaMidwayDestFix

org $00A261
autoclean JML StartSelectExit



; copy pasted from uberasm ($010B hack)
ORG $05D8B7
BRA +
NOP #3;the levelnum patch goes here in many ROMs, just skip over it
+
REP #$30
	LDA $0E		
	STA $010B|!addr
	ASL		
	CLC		
	ADC $0E		
	TAY		
	LDA.w $E000,Y
	STA $65		
	LDA.w $E001,Y
	STA $66		
	LDA.w $E600,Y
	STA $68		
	LDA.w $E601,Y
	STA $69		
	BRA +
ORG $05D8E0
	+


freecode

Table:
	incsrc retry_table.asm
	incsrc ../multiple_midway_settings.asm

Prompt:
	; save prompt
	CMP #$08
	BEQ .3
	CMP #$0C
	BEQ .3
	CMP #$09
	BCS Retry
	JSL $05B10C|!bank
	RTL
.3
	INC $1426|!addr
	STZ $41
	STZ $42
	STZ $43
	LDA #$80
	TRB $0D9F|!addr
	RTL

FastRetry:
	CMP #$0E
	BEQ Retry_5
	LDX $1B88|!addr
	LDA.l Retry_dest,x
	CMP $1B89|!addr
	BEQ Retry_sub2
	STA $1B89|!addr
	BRA Retry_sub


Retry:
	CMP #$0D
	BCS FastRetry
	CMP #$0A
	BNE .4

.5
;A
	LDA $1B87|!addr
	PHA
	JSR .choose
	PLA
	CMP $1B87|!addr
	BEQ +
	STA $1B87|!addr
	INC $1426|!addr
+
	RTL

.dest
	db $48,$00
.spd
	db $06,$FA

.4
;9,B
	LDX $1B88|!addr
	LDA $1B89|!addr
	CMP.l .dest,x
	BNE ++
;box complete
.sub2
	INC $1426|!addr
	LDA $1426|!addr
	CMP #$0A
	BEQ +++
	CMP #$0E
	BNE +
+++
;9
	LDA #$01
	STA $13D5|!addr
	STZ $22
	STZ $23
	STZ $24
	STZ $25
	LDY #$1E
	STY $12	; stripe image = save prompt
+
	AND #$03
	BEQ +
;9
	RTL
+
;B
	; terminate
	STZ $1426|!addr
	STZ $1B88|!addr
	STZ $41
	STZ $42
	STZ $43
	LDA #$80
	TRB $0D9F|!addr
	LDA #$02
	STA $44
	RTL
++
;box creating
	CLC
	ADC.l .spd,x
	STA $1B89|!addr
.sub
	CLC
	ADC #$80
	XBA
	REP #$10
	LDX #$016E
	LDA #$FF
-
	STA $04F0|!addr,x
	STZ $04F1|!addr,x
	DEX
	DEX
	BPL -
	SEP #$10
	LDA $1B89|!addr
	LSR
	ADC $1B89|!addr
	LSR
	AND #$FE
	TAX
	LDA #$80
	SEC
	SBC $1B89|!addr
	REP #$20
	LDY #$48
-
	CPY #$00
	BMI +
	STA $0548|!addr,y
+
	STA $0590|!addr,x
	DEY
	DEY
	DEX
	DEX
	BPL -
	SEP #$20
	LDA #$22
	STA $41
	STA $43
	LDA #$22
	STA $44
	LDA #$80
	TSB $0D9F|!addr
	RTL

.choose
	LDY #$00
	JSR .cursor
	TXA
	BEQ +

	; no is selected
	PHX
	JSR GetPromptType
	PLX
	CMP #$02
	BNE ++

	LDA !freeram+7
	BNE ++

	LDA.l $008075|!bank
	CMP #$5C
	BNE .no_amk
	if !death_jingle_alt == $FF
		BRA .van
	else
		LDA #!death_jingle_alt
		STA $1DFB|!addr
		BRA ++
	endif
.no_amk
	LDA #$FF
	STA $0DDA|!addr
.van
	LDA #$3E	; extra frames
	STA $1496|!addr
	LDA.l $00F60B|!bank
	STA $1DFB|!addr
++
	JSL $009C13|!bank
	RTS
+
	; yes is selected
	JSR ResetLevel
	JSL $009C13|!bank
	RTS

.cursor
	INC $1B91|!addr

	PHB
	LDA.b #$00|!bank8
	PHA
	PLB

	PHK
	PEA .pos-1
	PEA $9BAE
	JML $009E82|!bank
.pos
	PLB

	LDX $1B92|!addr
	LDA $16
	AND #$90
	BNE +
	LDA $18
	BPL ++
+
	LDA #$01
	STA $1DFC|!addr
	BRA +
++
	PLA
	PLA
	LDA $16
	AND #$20
	LSR
	LSR
	LSR
	ORA $16
	AND #$0C
	BEQ ++
	LDY #$06
	STY $1DFC|!addr
	STZ $1B91|!addr
	LSR
	LSR
	TAY

	PHB
	LDA #$00|!bank8
	PHA
	PLB
	TXA
	ADC $9AC7,y
	PLB
	CMP #$00

	BPL +++
	LDA $8A
	DEC
+++
	CMP $8A
	BCC ++++
+
	LDA #$00
++++
	STA $1B92|!addr
++
	RTS


ResetLevel:
	; 1) set screen exit
	LDA $5B
	LSR
	BCC .horz
	LDY $97
	BRA +
.horz
	LDY $95
+
	CPY #$00
	BPL .positive
	LDY #$00
	BRA .ok
.positive
	CPY #$20
	BMI .ok
	LDY #$1F
.ok
	LDA.l $05DAA3|!bank
	CMP #$5C
	BNE .non_mmp
	JSR CalcMMP
.non_mmp
	LDA !freeram+3
	STA $19B8|!addr,y
	LDA !freeram+4
	AND #$0F
	STA $19D8|!addr,y

	LDA #$01
	STA !freeram+5
	LDA #$00
	STA !freeram+7
	LDA #$06
	STA $71
	STZ $1496|!addr
	STZ $89
	STZ $88

	; 2) item memory & sprite reload
	LDX #$7F
-
	STZ $19F8|!addr,x
	STZ $1A78|!addr,x
	STZ $1AF8|!addr,x
	STZ $1938|!addr,x	; sprite reload
	DEX
	BPL -

	; 3) timer, music, lives, etc
	if !counter_break
		STZ $0DC2|!addr
	endif
	LDA #$1E
	STA $0DC0|!addr
	STZ $1420|!addr
	STZ $1422|!addr
	STZ $1432|!addr	; directional coin from a question box
	STZ $14AF|!addr	; ON/OFF
	STZ $1B94|!addr	; bonus game sprite
	STZ $1B95|!addr	; yoshi wing
	STZ $1B96|!addr	; side exit
	STZ $1B9A|!addr	; flying turn blocks(forest of illusion)
	STZ $1B9F|!addr	; reznor bridge
	; mode 7 values for the boss
	; do it later
	;REP #$20
	;STZ $36
	;STZ $38
	;STZ $3A
	;STZ $3C
	;SEP #$20
	LDA !freeram
	STA $0F31|!addr
	LDA !freeram+1
	STA $0F32|!addr
	LDA !freeram+2
	STA $0F33|!addr

	; yoshi drum
	LDA #$03
	STA $1DFA|!addr

	LDA.l $008075|!bank
	CMP #$5C
	BEQ .amk

	; non addmusic (dont need to consider sample overhead)
	LDA $0DDA|!addr	; after the death jingle, this value will always be $FF
	CMP !freeram+6
	BEQ .musicend
	STZ $0DDA|!addr
	BRA .musicend
.amk
	LDA $0DDA|!addr
	CMP #$FF	; death, kaizo trap, etc
	BEQ .spec
	; normal case: $0DDA preserved
	LDA !freeram+6
	CMP $0DDA|!addr
	BNE .musicend
	BRA .bypass
.spec
	LDA $1DFB|!addr
	CMP #$01	; death
	BEQ +
	; kaizo trap -> order reload (maybe improved, but not major)
	LDA #$00
	STA !addmusick_ram_addr
	STA $1DFB|!addr
+
	; death jingle
	LDA !freeram+6
	CMP !freeram+10
	BNE .musicend
.bypass
	LDA.l $05DAA3|!bank
	CMP #$5C
	BNE .non_mmp2
	; when !freeram+6 was unreliable due to the outside mmp then force to load the sample (maybe improved, but not major)
	JSR CalcMMPNum
	CMP !freeram+11
	BNE .musicend
.non_mmp2
	LDA #$01
	STA !addmusick_ram_addr+1
.musicend

	STZ $141A|!addr
	if !lose_lives
		DEC $0DBE|!addr
	endif
	RTS


CalcEntrance:
	PHX
	LDA $13BF|!addr
	CMP #$25
	BCC +
	CLC
	ADC #$DC
+
	STA !freeram+3
	LDA #$00
	ADC #$00
-
	STA !freeram+4
	LDX $13BF|!addr
	LDA $1EA2|!addr,x
	AND #$40
	BNE +
	LDA $13CE|!addr
	BEQ ++
+
	LDA !freeram+4
	ORA #$0C
	STA !freeram+4
	BRA +++
++
	; only for the first entrance (both mmp and this)
	LDA !freeram+4
	ORA #$04
	STA !freeram+4
+++
	PLX
	RTS
.2
	PHX
	LDA $010B|!addr
	STA !freeram+3
	LDA $010C|!addr
	BRA -



HardSave:
	LDA.l $05DAA3|!bank
	CMP #$5C
	BEQ .skip_mmp

	PHX
	LDA $13BF|!addr
	ASL
	TAX
	REP #$20
	LDA.l !freeram+3
	STA.l !freeram_checkpoint,x
	SEP #$20
	PLX
.skip_mmp
	RTS


LoadScrnImage:
	LDY $12
	CPY #$1E
	BNE .orig
	LDA $0100|!addr
	CMP #$14
	BNE .orig
	LDA.b #.stripe
	STA $00
	LDA.b #.stripe>>8
	STA $01
	LDA.b #.stripe>>16
	STA $02
	JML $0085E3|!bank
.orig
	LDA $84D0,y
	JML $0085D7|!bank
.stripe
	db $51,$CD,$00,$09
	db $1B,$38,$0E,$38,$1D,$38,$1B,$38,$22,$38	;RETRY

	db $52,$0D,$00,$07
	db $0E,$38,$21,$38,$12,$38,$1D,$38	;EXIT

	db $FF


DeathSFX:
	LDA #$90
	STA $7D
.pit
	LDA !freeram+7
	BNE .orig
	if !lose_lives
		LDA $0DBE|!addr
		BEQ .orig
	endif
	PHX
	JSR GetPromptType
	PLX
	CMP #$02
	BCC .orig
	CMP #$04
	BCS .orig
	LDA #!death_sfx
	STA !death_sfx_bank|!addr
	JML $00F614|!bank
.orig
	LDA $0DDA|!addr
	STA !freeram+10
	LDA.l $00F60B|!bank	; death jingle
	STA $1DFB|!addr
	JML $00F60F|!bank


HurryFlag:
	LDA #$FF
	STA $1DF9|!addr
	LDA #$01
	STA !freeram+7
	JML $008E60|!bank

	;echo
	Echo:
		incsrc ../sfx_echo_settings.asm


Request:
		;echo
		PHX
		LDX $010B|!addr
		LDA $010C|!addr
		BNE +
		LDA.l Echo,x
		BRA ++
	+
		LDA.l Echo+$100,x
	++
		BEQ +
		LDA $14
		AND #$01
		BNE +
		LDA #$06
		STA $1DFA|!addr
	+
		PLX

	if !lose_lives
		LDA $0DBE|!addr
		BEQ .orig
	endif
	; make sure mario is dying
	LDA $71
	CMP #$09
	BNE .orig

	; skip the first frame
	LDA $1496|!addr
	CMP #$31
	BNE +
	; extra frames
	LDA #$22
	STA $1496|!addr
	BRA .orig
+
	CMP #$30
	BCS .orig

	JSR GetPromptType
	CMP #$03
	BCC .prompt
	CMP #$04
	BCS .orig
	; automatically yes
	JSR .kaizo_trap
	JSR ResetLevel
	BRA .orig
.prompt
	; iggy/larry -> fast
	LDA $0D9B|!addr
	CMP #$80
	BEQ .fast
	; key press -> fast
	LDA $16
	ORA $18
	BPL ++
.fast
	LDA $1496|!addr
	CMP #$23
	BCC .orig
	LDA #$0C
	STA $1426|!addr	; request fast retry
	LDA #$22
	STA $1496|!addr
	BRA +++
++
	LDA $1496|!addr
	CMP #$23
	BNE .orig
	LDA #$08
	STA $1426|!addr	; request retry
	DEC $1496|!addr
+++
	JSR .settings
.orig
	LDA $0D9B|!addr
	BPL +
	JML $00A28F|!bank
+
	JML $00A295|!bank
.settings
	LDA $0D9B|!addr
	BPL +
	; special mode (boss)
	STZ $0D9B|!addr
	; window for boss battles
	LDA #$15
	STA $212C
	STA $212E
	STZ $212D
	STZ $212F
	; bg color to black
	STZ $0701|!addr
	STZ $0702|!addr
	LDA $13FC|!addr
	CMP #$04
	BNE .kaizo_trap
	; reznor battle -> erase all fireballs
	PHX
	LDX #$09
-
	LDA $170B|!addr,x
	CMP #$02
	BNE .f
	STZ $170B|!addr,x
.f
	DEX
	BPL -
	PLX
	BRA .kaizo_trap
+
	; normal mode
	; window (main/sub)
	LDA #$15
	STA $212C
	STA $212E
	LDA #$02
	STA $212D
	STA $212F
.kaizo_trap
	STZ $1492|!addr
	STZ $1493|!addr
	STZ $1494|!addr
	STZ $1495|!addr
	STZ $1B99|!addr
	RTS


GetPromptType:
	LDX $13BF|!addr
	BNE +
	LDA #$04
	RTS
+
	LDA.l Table_effect,x
	CMP #$01
	BCS .not_default
	LDA.b #(!default_prompt_type+1)
.not_default
	RTS


GeneralInit0:		; earlier than GeneralInit
	PHY
	PHP
	SEP #$20

	LDA $141A|!addr
	BNE +
	; initialize this ram when entering from the map
	LDA #$00
	STA !freeram+5	; zero because we don't want to trigger yoshi init & initial facing init
	BRA ++
+
	LDA.l $05DAA3|!bank
	CMP #$5C
	BEQ .skip_mmp

	LDA !freeram+5
	BNE ++
	REP #$10
	LDX $010B|!addr
	LDA.l Table_checkpoint,x
	SEP #$10
	CMP #$02
	BCC ++
	; (activates the transition midway)
	LDA !freeram+8
	STA !freeram+3
	LDA !freeram+9
	LDX $9D
	BEQ +
	ORA #$80
+
	STA !freeram+4
	JSR HardSave
	; too early for amk
	;LDA #$05
	;STA $1DF9|!addr
	LDX $13BF|!addr
	LDA $1EA2|!addr,x
	ORA #$40
	STA $1EA2|!addr,x
.skip_mmp
++

	LDA !freeram+5
	BEQ +
	if !counter_break == 0
		LDA $1B9B|!addr	; do not touch if $1B9B is set already (hence no effect on parked yoshi)
		BNE +
		; only for respawning(after death just in case) && not a castle level
	endif
	STZ $0DC1|!addr
+

	PLP
	PLY
	LDA #$0000
	SEP #$20
	JML $05D8EB|!bank


GeneralInit:
	LDA $141A|!addr
	BNE +
	; first entrance (from ow)
	LDA #$00
	STA !freeram+7

	LDA.l $05DAA3|!bank
	CMP #$5C
	BEQ .skip_mmp
	PHX
	LDX $13BF|!addr
	LDA $1EA2|!addr,x
	AND #$40
	BEQ .set_dest
	TXA
	ASL
	TAX
	REP #$20
	LDA.l !freeram_checkpoint,x
	STA.l !freeram+3
	SEP #$20
	BRA .end_dest
.set_dest
	JSR CalcEntrance
.end_dest
	PLX
.skip_mmp

	LDA $0F31|!addr
	STA !freeram
	LDA $0F32|!addr
	STA !freeram+1
	LDA $0F33|!addr
	STA !freeram+2
	BRA ++
+
	LDA !freeram+5
	BNE ++

	; normal transition (door/pipe/etc)
	LDA.l $05DAA3|!bank
	CMP #$5C
	BEQ .normal		; skip if mmp (no transition midpt)

	PHX
	REP #$10
	LDX $010B|!addr
	LDA.l Table_checkpoint,x
	SEP #$10
	PLX
	CMP #$02
	BCC .normal

++
	; (initial entrance from ow or after death or transition midpt)
	; 1) reset mode 7 values for the boss (consistency)
	REP #$20
	STZ $36
	STZ $38
	STZ $3A
	STZ $3C
	SEP #$20
	; a) mmp only: midway number (of mmp) whos music is backed up (initial entrance from ow or after death)
	LDA.l $05DAA3|!bank
	CMP #$5C
	BNE .not_mmp
	JSR CalcMMPNum
	STA !freeram+11
	BRA +++
.not_mmp
	; b) non-mmp only: recover the freeze state
	LDA !freeram+4
	BPL .no_freeze
	LDA #$01
	STA $9D
	BRA +++
.no_freeze
	STZ $9D
+++
	; 2) music backup
	LDA.l $008075|!bank
	CMP #$5C
	BEQ +
	; nonamk
	LDA $0DDA|!addr
	AND #$3F
	STA !freeram+6
	BRA .normal
+
	; amk
	LDA $0DDA|!addr
	STA !freeram+6
.normal

	; common (orig)
	LDA #$00
	STA !freeram+5	; this flag is completely used -> reset
	LDA $141A|!addr
	BNE +
	JML $0091AB|!bank
+
	JML $0091B0|!bank


YoshiInit:
	LDA $1B9B|!addr
	ORA !freeram+5
	BNE +
	JML $02A76D|!bank
+
	JML $02A771|!bank


EntranceInit0:
	JSR ScreenIndexAdjust
	LDA $19B8|!addr,x
	STA $17BB|!addr
	JML $05D7C3|!bank


EntranceInit:		; activated by all kind of transitions (normal things like door/pipe, or the retry)
	LDA !freeram+5
	BNE .orig
	LDX $95
	LDA $5B
	AND #$01
	BEQ +
	LDX $97
+
	JSR ScreenIndexAdjust
	LDA $19B8|!addr,x
	STA !freeram+8
	LDA $19D8|!addr,x
	STA !freeram+9
.orig
	LDA $1B93|!addr
	BEQ +
	JML $05D7D9|!bank
+
	JML $05D83B|!bank


ScreenIndexAdjust:
	CPX #$00
	BPL .positive
	LDX #$00
	BRA .ok
.positive
	CPX #$20
	BMI .ok
	LDX #$1F
.ok
	RTS


MidbarHijack:
	LDA.l $05DAA3|!bank
	CMP #$5C
	BEQ .skip_mmp

	PHX
	REP #$10
	LDX $010B|!addr
	LDA.l Table_checkpoint,x
	SEP #$10
	PLX
	CMP #$01
	BEQ +
	CMP #$03
	BCS +
	JSR CalcEntrance	; to the main level's midway
	BRA ++
+
	JSR CalcEntrance_2	; to the current sublevel's midway
++
	JSR HardSave

	; music backup
	LDA.l $008075|!bank
	CMP #$5C
	BEQ +
	; nonamk
	LDA $0DDA|!addr
	AND #$3F
	STA !freeram+6
	BRA ++
+
	; amk
	LDA $0DDA|!addr
	STA !freeram+6
++

.skip_mmp
	LDA #$05
	STA $1DF9|!addr
	JML $00F2ED|!bank


; always spawn the midway bar if another checkpoint is being activated (i.e. every checkpoint has the same priority) 
MidbarSpawn:
	LDA.l $05DAA3|!bank
	CMP #$5C
	BNE +
	; mmp -> orig
	LDA $1EA2|!addr,x
	JML $0DA695|!bank
+

	LDA $1EA2|!addr,x
	AND #$40
	BNE +
	LDA $13CE|!addr
	BNE +
.true
	JML $0DA69E|!bank
+
	PHX
	PHP
	REP #$10
	LDX $010B|!addr
	LDA.l Table_checkpoint,x
	PLP
	PLX
	CMP #$01
	BCS +
	; main midway settings
	LDA $13BF|!addr
	REP #$20
	AND #$00FF
	CMP #$0025
	BCC ++
	CLC
	ADC #$00DC
	BRA ++
+
	; sublevel midway settings
	REP #$20
	LDA $010B|!addr
++
	ORA #$0C00
	EOR !freeram+3
	AND #$7FFF
	;CMP !freeram+3
	SEP #$20
	BNE .true
	JML $0DA6B0|!bank


CheckMidwayEntrance:
	LDA.l $05DAA3|!bank
	CMP #$5C
	BNE +
	; mmp -> orig
	LDA $1EA2|!addr,x
	AND #$40
	JML $05D9DC|!bank
+
	; not mmp
	LDA $1EA2|!addr,x
	AND #$40
	STA $13CF|!addr	; for no yoshi intro
	BEQ .normal	; also if no checkpoint is obtained, midway entrances can never be the case (vanilla)
	PHX
	TXA
	ASL
	TAX
	LDA.l !freeram_checkpoint+1,x
	PLX		; fixed the bug after v2.03
	AND #$0A
	CMP #$08		; check the midway exit bit
	BEQ +
.normal
	; normal target
	JML $05D9EC|!bank
+
	; midway target
	LDA $1EA2|!addr,x
	AND #$40
	JML $05D9DE|!bank	; go to the routine called "secondary_exits"



InitCheckpointRam:
	LDA.l $05DAA3|!bank
	CMP #$5C
	BEQ .skip_mmp

	LDX #$BE
	LDY #$5F
-
	TYA
	CMP #$25
	BCC +
	CLC
	ADC #$DC
+
	STA !freeram_checkpoint,x
	LDA #$00
	ADC #$00
	ORA #$0C	; midpoint (default)
	STA !freeram_checkpoint+1,x
	DEX
	DEX
	DEY
	BPL -
.skip_mmp
	; orig
	LDA #$EB
	LDY #$00
	JML $0096CF|!bank



VanillaMidwayDestFix:
	LDA $141A|!addr		; first entrance -> vanilla ok
	BEQ .orig2
	LDA.l $05D9E3|!bank		; check if lm hack is applied
	CMP #$22
	BNE .orig2
	LDA.l !freeram+5	; only for respawning (when !freeram+3 is the target dest) ; todo? -> no (because doors in wing levels work differently)
	BEQ .orig2
	LDA.l !freeram+4
	AND #$0A
	CMP #$08		; check the midway exit bit
	BEQ .cnt
.orig2
	JMP .orig
.cnt
	LDA $03
	PHA
	LDA $04
	PHA
	LDA $05
	PHA

	LDA.l $05D9E6|!bank
	STA $05
	REP #$30
	LDA.l $05D9E4|!bank
	CLC
	ADC #$000A
	STA $03
	LDA [$03]
	PHA
	INC $03
	LDA [$03]
	STA $04
	PLA
	STA $03
	LDA !freeram+3
	AND #$01FF
	TAY
	SEP #$20

	; set the screen number of midway entrance
	LDA [$03],y
	AND #$10
	STA $01		; 5th bit

	LDA $F400,y
	LSR #4
	ORA $01
	STA $01		; 1-4th bit (0-F)

	LDA [$03],y
	BIT #$20
	BNE .ret	; separate midway -> already set correctly

	; correct the slippery/water for vanilla midway
	LDA #$C0
	TRB $192A|!addr
	LDA $DE00,y
	AND #$C0
	ORA $192A|!addr
	STA $192A|!addr

	; correct the camera position for vanilla midway
	LDA #$00
	XBA
	LDA $F400,y
	STA $02
	AND #$03
	TAX
	LDA $D70C,x
	STA $20
	LDA $02
	AND #$0C
	LSR #2
	TAX
	LDA $D708,x
	STA $1C

	; correct the position if x/y pos method 2 is used
	LDA $D97D
	CMP #$22
	BNE .ret

	LDA $DE00,y
	TAX
	LDA $D980
	STA $05
	LDA $D97E
	CLC
	ADC #$10
	STA $03
	LDA $D97F
	ADC #$00
	STA $04
	JSL .jml
.ret
	PLA
	STA $05
	PLA
	STA $04
	PLA
	STA $03
.orig
	REP #$10
	LDA $01
	JML $05D9F0|!bank
.jml
	JML [$0003|!dp]


; subroutine: returns 0 or [!RAM_Midway],lv+1
CalcMMPNum:
	PHY
	LDY $13BF|!addr
	LDA $1EA2|!addr,y
	AND #$40
	BNE +
	LDA $13CE|!addr
	BNE +
	; no midpt yet
	LDA #$00
	PLY
	RTS
+
	REP #$20
	LDA $03
	PHA
	LDA $05
	PHA
	SEP #$20

	; getting the address of !RAM_Midway
	LDA.l $05D845|!bank
	STA $05
	REP #$20
	LDA.l $05D843|!bank
	CLC
	ADC #$0025
	STA $03
	LDA [$03]
	PHA
	INC $08
	INC $08
	LDA [$03]
	STA $05
	PLA
	STA $03

	; midway status of the current level
	SEP #$20
	LDY $13BF|!addr
	LDA [$03],y
	TAY

	REP #$20
	PLA
	STA $05
	PLA
	STA $03
	SEP #$20
	TYA
	PLY
	INC
	RTS


CalcMMP:
	PHY
	LDY $13BF|!addr
	LDA $1EA2|!addr,y
	AND #$40
	BNE +
	LDA $13CE|!addr
	BNE +
	; no midpt yet
	JSR CalcEntrance
	PLY
	RTS
+
	REP #$20
	LDA $03
	PHA
	LDA $05
	PHA
	LDA $07
	PHA
	LDA $09
	PHA
	SEP #$20

	; getting the address of !RAM_Midway
	LDA.l $05D845|!bank
	STA $0A
	REP #$20
	LDA.l $05D843|!bank
	CLC
	ADC #$0025
	STA $08
	LDA [$08]
	STA $03
	INC $08
	INC $08
	SEP #$20
	LDA [$08]
	STA $05

	; getting the value of !total_midpoints
	REP #$20
	LDA $08
	CLC
	ADC #$000D
	STA $08
	LDA [$08]
	STA $06

	; getting the address of level_mid_tables
	LDA $08
	CLC
	ADC #$0006
	STA $08
	LDA [$08]
	STA $08

	; midway status of the current level
	SEP #$20
	LDY $13BF|!addr
	LDA [$03],y
	STA $03
	STZ $04

	; index for the table
	; assuming !total_midpoints < 256
	; multiplication
	STY $4202
	LDA $06
	STA $4203
	NOP #4		; 8 cycles for multiplication
	REP #$30
	LDA $4216
	CLC
	ADC $03
	ASL
	TAY

	; get the table val
	LDA [$08],y
	SEP #$10
	STA $08

	CMP #$1000
	BCS .sec
; midway entrance
	AND #$01FF
	ORA #$0C00
	BRA +
.sec
; secondary entrance
	AND #$01FF
	ORA #$0600
+
	STA !freeram+3

	PLA
	STA $09
	PLA
	STA $07
	PLA
	STA $05
	PLA
	STA $03
	SEP #$20
	PLY
	RTS



StartSelectExit:
	PHX
	JSR GetPromptType
	PLX
	CMP #$03
	BEQ +
	LDY $13BF|!addr
	LDA $1EA2|!addr,y
	JML $00A267|!bank
+
	JML $00A269|!bank




org $00D0D8
if !lose_lives
	DEC $0DBE|!addr
else
	NOP #3
endif



if read1($008075) == $5C
	;print "Detected AddmusicK"
endif



; handling compatibility (sprite init facing fix)
if read1($05D971) == $22
	;print "Detected the 'Sprite Initial Facing Fix' patch"
else
	org $05D971
	autoclean JML InitFace1

	org $05D9FC
	autoclean JML InitFace2

	org $05DA03
	autoclean JML InitFace3

	freecode
	InitFace1:
		LDA.l $05DAA3|!bank
		CMP #$5C
		BEQ +
		PHX
		LDX $010B|!addr
		LDA.l Table_checkpoint,x
		PLX
		CMP #$02
		BCS ++
		LDA !freeram+5
		BEQ +
	++
		LDA $94
		STA $D1		; new
		LDA $96		; new
		STA $D3		; new
		LDA $97		; new
		STA $D4		; new
		LDA.l $05D758|!bank,x
		STA $D2		; new
		JML $05D975|!bank
	+
		LDA.l $05D758|!bank,x
		JML $05D975|!bank

	InitFace2:
		STA $95
		LDA.l $05DAA3|!bank
		CMP #$5C
		BEQ +
		PHX
		LDX $010B|!addr
		LDA.l Table_checkpoint,x
		PLX
		CMP #$02
		BCS ++
		LDA !freeram+5
		BEQ +
	++
		LDA $95
		STA $D2		;new
	+
		JML $05DA17|!bank

	InitFace3:
		STA $97
		STA $1D
		LDA.l $05DAA3|!bank
		CMP #$5C
		BEQ +
		PHX
		LDX $010B|!addr
		LDA.l Table_checkpoint,x
		PLX
		CMP #$02
		BCS ++
		LDA !freeram+5
		BEQ +
	++
		STA $D4		;new
	+
		LDA $97
		JML $05DA07|!bank
endif



; handling compatibility (multiple midway)
if read1($05DAA3) == $5C
	;print "Detected the 'Multiple Midway Points 1.6' patch"
else
	org $05D842
		autoclean JML mmp_main

	ORG $05D9DE
		autoclean JML secondary_exits	; additional code for secondary exits

	org $048F74
		autoclean JML reset_midpoint	; hijack the code that resets the midway point

	org $05DAA3
		autoclean JSL no_yoshi		; make secondary exits compatible with no yoshi intros

	freecode

	mmp_main:
		LDA $141A|!addr		; skip if not the opening level
		BNE .return
		LDA $1B93|!addr		; prevent infinite loop if using a secondary exit
		BNE .return
		LDA $0109|!addr
		BNE .code_05D8A2
		JSR get_translevel
		TAY
		ASL
		TAX
		LDA $1EA2|!addr,y
		AND #$40
		BEQ .return		; check if any midway is activated previously
		LDA.l !freeram_checkpoint+1,x
		AND #$02		; check the 2ndary exit bit
		BNE .secondary_exit
		REP #$20
		LDA.l !freeram_checkpoint,x
		AND #$01FF
		STA $0E			; store level number
		JML $05D8B7|!bank		; no need to restore the processr mode
	.return
		JML $05D847|!bank
	.code_05D8A2
		JML $05D8A2|!bank
	.secondary_exit
		LDA.l !freeram_checkpoint,x
		STA $19B8|!addr		; store secondary exit number (low)
		LDA.l !freeram_checkpoint+1,x
		AND #$0F
		STA $19D8|!addr		; store secondary exit number (high and properties)
		STZ $95			; set these to 0
		STZ $97
		JML $05D7B3|!bank		; return and load level at a secondary exit position

	secondary_exits:
		LDX $1B93|!addr		; check if using a secondary exit for this
		BNE .return		; if so, skip the code that sets mario's x position to the midway entrance
		STA $13CF|!addr		; restore old code
		LDA $02			; restore old code
		JML $05D9E3|!bank		; return
	.return	
		JML $05D9EC|!bank		; return without setting mario's x to the midway entrance

	reset_midpoint:
		STA $1EA2|!addr,x		; restore old code
		INC $13D9|!addr
		TXA
		ASL
		TAX
		LSR
		CMP #$0025
		BCC +
		CLC
		ADC #$00DC
	+
		ORA #$0C00
		STA !freeram_checkpoint,x
		JML $048F7A|!bank		; return

	no_yoshi:
		STZ $1B93|!addr		; reset this (prevents glitch with no yoshi intros and secondary entrances)
		LDA $05D78A|!bank,x		; restore old code
		RTL

	get_translevel:
		LDY $0DD6|!addr		;get current player*4
		LDA $1F17|!addr,y		;ow player X position low
		LSR #4
		STA $00
		LDA $1F19|!addr,y		;ow player y position low
		AND #$F0
		ORA $00
		STA $00
		LDA $1F1A|!addr,y		;ow player y position high
		ASL
		ORA $1F18|!addr,y		;ow player x position high
		LDY $0DB3|!addr		;get current player
		LDX $1F11|!addr,y		;get current map
		BEQ +
		CLC : ADC #$04		;if on submap, add $0400
	+	STA $01
		REP #$10
		LDX $00
		LDA !7ED000,x		;load layer 1 tilemap, and thus current translevel number
		STA $13BF|!addr
		SEP #$10
		RTS
endif
