;This patch fixes:
;-Hdma issue and message box problems when first hitting it after exiting a pipe.
; -I had to do this rather than hijacking $00CDE8 (the routine that clears $9D, the freeze
;  flag, part of the camera scroll routine from L/R, runs every frame) because (1), its
;  intrusive, and (2) uberasm's hijacks are located AFTER the routine that makes mario react
;  to the controls (some controls like jumping won't get disabled).
;-Entering yoshi automatically if you enter left, right, or up facing pipes while
; ovelapping its saddle hitbox.
;-Since $72 is bad to use in interactive layer 2 levels (it assumes mario is falling
; during a block routine EVEN if you are on ground), so the only way for horizontal pipes
; to detect if mario is on the ground is to use $77 (the blocked status). Too bad $00EAA9
; (this clears out blocked and slope status as well as decompressed graphics flag) runs before
; the custom blocks routine, causing blocks to always assume $77 is #$00. So I had to hijack
; it and save it to a freeram and let it clear $77 right after (so that it clears when mario
; is touching nothing).

!Freeram_PipeDir	= $60		;>[1 byte] this controls the directions within a pipe.
!Freeram_PipeTmr	= $61		;>[1 byte] for exiting and entering animations.
!Freeram_EntrExtFlg	= $62		;>[1 byte] use to determine if mario's entering or exiting.
!Freeram_CarrySpr	= $63		;>[1 byte] used for if mario enters a pipe while holding a sprite.
!Freeram_BlockedStatBkp	= $79		;>[1 byte] A backup of $77 to determine if mario is on the ground.

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SA1 detector:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	!dp = $0000
	!addr = $0000
	!sa1 = 0
	!gsu = 0

if read1($00FFD6) == $15
	sfxrom
	!dp = $6000
	!addr = !dp
	!gsu = 1
elseif read1($00FFD5) == $23
	sa1rom
	!dp = $3000
	!addr = $6000
	!sa1 = 1
endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org $00C5CE				;\fix hdma issues (like message box) when setting
	nop #8				;/$7E0071 to #$0B.

org $01ED44				;\fix getting on yoshi automatically when entering
	autoclean JML GetOnYoshiExcept	;/horizontal pipes while ovelapping yoshi's saddle.

org $00EAA9				;\This is why blocks always assume $77, $13E1 and $13EE
	autoclean JSL BlockedFix	;/are stored as zero (this runs every frame).
	nop #1

freecode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GetOnYoshiExcept:
	LDA $7D			;\Restore speed check in order to get on yoshi.
	BMI .NoYoshi		;/
	LDA !Freeram_PipeDir	;>for some reason, checking $7E0071 (probably because it doesn't assume the
				; values for it yet) doesn't work, so I had to check pipe direction instead.
;	ORA !Cusfreeram		;>In case if you want to disable mounting yoshi in other ways.
	BNE .NoYoshi
	JML $01ED48		;>Get on yoshi

	.NoYoshi
	JML $01ED70		;>Don't get on yoshi.


BlockedFix:
;	LDA $13E1+!addr		;\In case you also wanted blocks to detect slope, remove
;	STA $xxxxxx			;/the semicolons (";") before it and add a freeram in place of xxxxxx
	STZ $13E1+!addr		;>Restore code (clears slope type)

	LDA $77				;\backup/save block status for use for blocks...
	STA !Freeram_BlockedStatBkp		;/
	STZ $77				;>...before its cleared.

	;^This (or both) freeram will get cleared when $77 and/or $13E1
	; gets cleared on the next frame due to a whole big loop SMW runs.
	; when mario isn't touching a solid object.

	;So after executing $00EAA9, you should use the freeram that has
	;the blocked and/or slope status saved in them. If before $00EAA9,
	;then use the original ($77 and/or $13E1). Do not write a value on
	;this freeram, it will do nothing, write on those default ram address.
	RTL